(set-logic QF_NIA)
(set-info
  :source |
SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of 
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument [2].

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to the benchmarks from the SV-COMP 2015 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2015-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann:
Geometric Series as Nontermination Arguments for Linear Lasso Programs. 
CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model 
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2015/
[6] Dirk Beyer: Software Verification and Verifiable Witnesses - (Report on 
SV-COMP 2015). TACAS 2015: 401-416
[7] https://svn.sosy-lab.org/software/sv-benchmarks/tags/svcomp15/
|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun |init_main_#t~malloc2.base| () Int)
(declare-fun |honda_main_#t~malloc2.base| () Int)
(declare-fun |ray_main_#t~malloc2.base| () Int)
(declare-fun init_main_~z~2.base () Int)
(declare-fun honda_main_~z~2.base () Int)
(declare-fun ray_main_~z~2.base () Int)
(declare-fun |init_main_#t~malloc0.base| () Int)
(declare-fun |honda_main_#t~malloc0.base| () Int)
(declare-fun |ray_main_#t~malloc0.base| () Int)
(declare-fun init_main_~x~2.base () Int)
(declare-fun honda_main_~x~2.base () Int)
(declare-fun ray_main_~x~2.base () Int)
(declare-fun |init_main_#t~malloc2.offset| () Int)
(declare-fun |honda_main_#t~malloc2.offset| () Int)
(declare-fun |ray_main_#t~malloc2.offset| () Int)
(declare-fun |init_main_#t~mem15| () Int)
(declare-fun |honda_main_#t~mem15| () Int)
(declare-fun |ray_main_#t~mem15| () Int)
(declare-fun |init_main_#t~malloc1.offset| () Int)
(declare-fun |honda_main_#t~malloc1.offset| () Int)
(declare-fun |ray_main_#t~malloc1.offset| () Int)
(declare-fun |init_main_#t~mem9| () Int)
(declare-fun |honda_main_#t~mem9| () Int)
(declare-fun |ray_main_#t~mem9| () Int)
(declare-fun |init_main_#t~mem14| () Int)
(declare-fun |honda_main_#t~mem14| () Int)
(declare-fun |ray_main_#t~mem14| () Int)
(declare-fun |init_main_#t~nondet7| () Int)
(declare-fun |honda_main_#t~nondet7| () Int)
(declare-fun |ray_main_#t~nondet7| () Int)
(declare-fun |init_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid 0) 1 0)| () Int)
(declare-fun init_main_~z~2.offset () Int)
(declare-fun honda_main_~z~2.offset () Int)
(declare-fun ray_main_~z~2.offset () Int)
(declare-fun |init_#NULL.offset| () Int)
(declare-fun |honda_#NULL.offset| () Int)
(declare-fun |ray_#NULL.offset| () Int)
(declare-fun |init_main_#t~malloc0.offset| () Int)
(declare-fun |honda_main_#t~malloc0.offset| () Int)
(declare-fun |ray_main_#t~malloc0.offset| () Int)
(declare-fun init_main_~y~2.base () Int)
(declare-fun honda_main_~y~2.base () Int)
(declare-fun ray_main_~y~2.base () Int)
(declare-fun |init_main_#t~malloc1.base| () Int)
(declare-fun |honda_main_#t~malloc1.base| () Int)
(declare-fun |ray_main_#t~malloc1.base| () Int)
(declare-fun |init_main_#t~nondet3| () Int)
(declare-fun |honda_main_#t~nondet3| () Int)
(declare-fun |ray_main_#t~nondet3| () Int)
(declare-fun |init_main_#t~nondet5| () Int)
(declare-fun |honda_main_#t~nondet5| () Int)
(declare-fun |ray_main_#t~nondet5| () Int)
(declare-fun init_main_~y~2.offset () Int)
(declare-fun honda_main_~y~2.offset () Int)
(declare-fun ray_main_~y~2.offset () Int)
(declare-fun |init_main_#t~mem10| () Int)
(declare-fun |honda_main_#t~mem10| () Int)
(declare-fun |ray_main_#t~mem10| () Int)
(declare-fun init_main_~x~2.offset () Int)
(declare-fun honda_main_~x~2.offset () Int)
(declare-fun ray_main_~x~2.offset () Int)
(declare-fun |init_main_#t~mem11| () Int)
(declare-fun |honda_main_#t~mem11| () Int)
(declare-fun |ray_main_#t~mem11| () Int)
(declare-fun |init_#NULL.base| () Int)
(declare-fun |honda_#NULL.base| () Int)
(declare-fun |ray_#NULL.base| () Int)
(declare-fun
  |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| () Int)
(declare-fun
  |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| () Int)
(declare-fun |honda_(ite (select #valid main_~y~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~y~2.base) 1 0)| () Int)
(declare-fun |honda_(select #length main_~x~2.base)| () Int)
(declare-fun |ray_(select #length main_~x~2.base)| () Int)
(declare-fun |honda_(select old(#length) main_~z~2.base)| () Int)
(declare-fun |ray_(select old(#length) main_~z~2.base)| () Int)
(declare-fun |honda_(ite (select #valid main_~z~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~z~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid main_~x~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~x~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| () Int)
(declare-fun
  |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| () Int)
(declare-fun |honda_(select #length main_~y~2.base)| () Int)
(declare-fun |ray_(select #length main_~y~2.base)| () Int)
(declare-fun |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)| ()
  Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)| ()
  Int)
(declare-fun |honda_(select old(#length) main_~y~2.base)| () Int)
(declare-fun |ray_(select old(#length) main_~y~2.base)| () Int)
(declare-fun |honda_(select #length main_~z~2.base)| () Int)
(declare-fun |ray_(select #length main_~z~2.base)| () Int)
(declare-fun |honda_(select old(#length) main_~x~2.base)| () Int)
(declare-fun |ray_(select old(#length) main_~x~2.base)| () Int)
(declare-fun |honda_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)| ()
  Int)
(declare-fun |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| () Int)
(declare-fun lambda () Int)
(declare-fun aux_768 () Int)
(declare-fun aux_769 () Int)
(declare-fun aux_772 () Int)
(declare-fun aux_774 () Int)
(declare-fun aux_775 () Int)
(declare-fun aux_778 () Int)
(declare-fun aux_780 () Int)
(declare-fun aux_781 () Int)
(declare-fun aux_784 () Int)
(declare-fun aux_786 () Int)
(declare-fun aux_787 () Int)
(declare-fun aux_790 () Int)
(declare-fun aux_792 () Int)
(declare-fun aux_793 () Int)
(declare-fun aux_796 () Int)
(declare-fun aux_798 () Int)
(declare-fun aux_799 () Int)
(declare-fun aux_802 () Int)
(declare-fun aux_804 () Int)
(declare-fun aux_805 () Int)
(declare-fun aux_808 () Int)
(declare-fun aux_810 () Int)
(declare-fun aux_811 () Int)
(declare-fun aux_814 () Int)
(declare-fun aux_816 () Int)
(declare-fun aux_817 () Int)
(declare-fun aux_820 () Int)
(declare-fun aux_822 () Int)
(declare-fun aux_823 () Int)
(declare-fun aux_826 () Int)
(declare-fun aux_828 () Int)
(declare-fun aux_829 () Int)
(declare-fun aux_832 () Int)
(declare-fun aux_834 () Int)
(declare-fun aux_835 () Int)
(declare-fun aux_838 () Int)
(declare-fun aux_840 () Int)
(declare-fun aux_841 () Int)
(declare-fun aux_844 () Int)
(declare-fun aux_846 () Int)
(declare-fun aux_847 () Int)
(declare-fun aux_850 () Int)
(declare-fun aux_852 () Int)
(declare-fun aux_853 () Int)
(declare-fun aux_856 () Int)
(declare-fun aux_858 () Int)
(declare-fun aux_859 () Int)
(declare-fun aux_862 () Int)
(declare-fun aux_864 () Int)
(declare-fun aux_865 () Int)
(declare-fun aux_868 () Int)
(declare-fun aux_870 () Int)
(declare-fun aux_871 () Int)
(declare-fun aux_874 () Int)
(declare-fun aux_876 () Int)
(declare-fun aux_877 () Int)
(declare-fun aux_880 () Int)
(declare-fun aux_882 () Int)
(declare-fun aux_883 () Int)
(declare-fun aux_886 () Int)
(declare-fun aux_888 () Int)
(declare-fun aux_889 () Int)
(declare-fun aux_892 () Int)
(declare-fun aux_894 () Int)
(declare-fun aux_895 () Int)
(declare-fun aux_898 () Int)
(declare-fun aux_900 () Int)
(declare-fun aux_901 () Int)
(declare-fun aux_904 () Int)
(declare-fun aux_906 () Int)
(declare-fun aux_907 () Int)
(declare-fun aux_910 () Int)
(assert
 (and
 (or
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_768 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_769 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_769 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_768 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_772 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_772 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_774 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_775 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_775 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_774 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_778 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_778 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_780 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_781 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_781 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_780 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_784 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_784 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_786 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_787 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_787 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_786 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_790 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_790 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_792 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_793 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_793 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_792 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_796 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_796 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_798 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_799 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_799 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_798 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_802 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_802 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_804 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_805 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_805 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_804 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_808 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_808 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_810 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_811 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_811 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_810 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_814 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_814 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_816 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_817 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_817 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_816 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_820 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_820 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_822 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_823 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_823 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_822 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_826 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_826 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_828 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_829 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_829 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_828 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_832 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_832 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_834 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_835 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_835 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_834 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_838 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_838 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_840 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_841 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_841 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_840 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_844 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_844 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_846 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_847 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_847 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_846 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_850 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_850 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_852 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_853 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_853 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_852 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_856 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_856 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_858 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_859 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_859 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_858 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_862 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_862 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_864 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_865 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_865 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_864 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_868 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_868 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_870 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_871 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_871 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_870 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_874 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_874 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_876 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_877 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_877 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_876 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_880 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_880 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_882 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_883 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_883 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_882 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_886 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_886 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_888 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_889 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_889 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_888 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_892 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_892 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_894 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_895 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_895 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_894 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_898 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_898 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 1)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_900 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_901 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_901 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_900 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_904 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_904 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0))
 (and (= |init_main_#t~mem15| |honda_main_#t~mem15|)
 (= |init_main_#t~mem9| |honda_main_#t~mem9|)
 (= |init_main_#t~mem14| |honda_main_#t~mem14|)
 (= |init_main_#t~mem10| |honda_main_#t~mem10|)
 (= |init_main_#t~mem11| |honda_main_#t~mem11|)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_906 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_(select #length main_~y~2.base)| 0)
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_907 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| (- 1))
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| (- 1))
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 1) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset (- 1))
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 1) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1)) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 1)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_907 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base (- 1))
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_906 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_910 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* aux_910 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 1)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0)
 (* honda_main_~z~2.offset (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_main_#t~malloc0.base| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~nondet7| 0) 
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~z~2.base)| 0)
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet3| 0)
 (* |honda_(ite (select #valid main_~z~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* honda_main_~y~2.offset 0)
 (* |honda_(ite (select old(#valid) main_~z~2.base) 1 0)| 0)
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select #length main_~y~2.base)| 0) 
 (* honda_main_~z~2.base 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 0) (* honda_main_~x~2.base 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(select #length main_~z~2.base)| 0) 
 (* honda_main_~z~2.offset 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0) (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_main_#t~nondet5| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* |init_main_#t~malloc2.base| 0) 
 (* init_main_~z~2.base 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~nondet7| 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* init_main_~z~2.offset 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet3| 0) 
 (* |init_main_#t~nondet5| 0) 
 (* init_main_~y~2.offset 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) 0) 0)))
 (or
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(select old(#length) main_~z~2.base)|
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~z~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= honda_main_~z~2.base (+ honda_main_~z~2.base ray_main_~z~2.base))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select #length main_~z~2.base)|
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_main_~z~2.offset (+ honda_main_~z~2.offset ray_main_~z~2.offset))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 1)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(select old(#length) main_~z~2.base)|
 (* |ray_(select old(#length) main_~z~2.base)| lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~z~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= ray_main_~z~2.base (* ray_main_~z~2.base lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda)) (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select #length main_~z~2.base)|
 (* |ray_(select #length main_~z~2.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_main_~z~2.offset (* ray_main_~z~2.offset lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(select old(#length) main_~z~2.base)|
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~z~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= honda_main_~z~2.base (+ honda_main_~z~2.base ray_main_~z~2.base))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select #length main_~z~2.base)|
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_main_~z~2.offset (+ honda_main_~z~2.offset ray_main_~z~2.offset))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 1)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(select old(#length) main_~z~2.base)|
 (* |ray_(select old(#length) main_~z~2.base)| lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~z~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= ray_main_~z~2.base (* ray_main_~z~2.base lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda)) (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select #length main_~z~2.base)|
 (* |ray_(select #length main_~z~2.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_main_~z~2.offset (* ray_main_~z~2.offset lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(select old(#length) main_~z~2.base)|
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~z~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= honda_main_~z~2.base (+ honda_main_~z~2.base ray_main_~z~2.base))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select #length main_~z~2.base)|
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_main_~z~2.offset (+ honda_main_~z~2.offset ray_main_~z~2.offset))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 1)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(select old(#length) main_~z~2.base)|
 (* |ray_(select old(#length) main_~z~2.base)| lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~z~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= ray_main_~z~2.base (* ray_main_~z~2.base lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda)) (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select #length main_~z~2.base)|
 (* |ray_(select #length main_~z~2.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_main_~z~2.offset (* ray_main_~z~2.offset lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(select old(#length) main_~z~2.base)|
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~z~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= honda_main_~z~2.base (+ honda_main_~z~2.base ray_main_~z~2.base))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select #length main_~z~2.base)|
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_main_~z~2.offset (+ honda_main_~z~2.offset ray_main_~z~2.offset))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 1)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(select old(#length) main_~z~2.base)|
 (* |ray_(select old(#length) main_~z~2.base)| lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~z~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= ray_main_~z~2.base (* ray_main_~z~2.base lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda)) (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select #length main_~z~2.base)|
 (* |ray_(select #length main_~z~2.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_main_~z~2.offset (* ray_main_~z~2.offset lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(select old(#length) main_~z~2.base)|
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~z~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= honda_main_~z~2.base (+ honda_main_~z~2.base ray_main_~z~2.base))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select #length main_~z~2.base)|
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_main_~z~2.offset (+ honda_main_~z~2.offset ray_main_~z~2.offset))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 1)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(select old(#length) main_~z~2.base)|
 (* |ray_(select old(#length) main_~z~2.base)| lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~z~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= ray_main_~z~2.base (* ray_main_~z~2.base lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda)) (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select #length main_~z~2.base)|
 (* |ray_(select #length main_~z~2.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_main_~z~2.offset (* ray_main_~z~2.offset lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~nondet7|
 (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(select old(#length) main_~z~2.base)|
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|))
 (= |honda_main_#t~nondet3|
 (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~z~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= honda_main_~z~2.base (+ honda_main_~z~2.base ray_main_~z~2.base))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select #length main_~z~2.base)|
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_main_~z~2.offset (+ honda_main_~z~2.offset ray_main_~z~2.offset))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_main_#t~nondet5|
 (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 1)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 1)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~nondet7| |ray_main_#t~nondet7|) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (*
 (+ |honda_(select old(#length) main_~z~2.base)|
 |ray_(select old(#length) main_~z~2.base)|) 0)
 (* (+ |honda_main_#t~nondet3| |ray_main_#t~nondet3|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~z~2.base) 1 0)|
 |ray_(ite (select #valid main_~z~2.base) 1 0)|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~z~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~mem10| |ray_main_#t~mem10|) 0)
 (* (+ |honda_main_#t~mem11| |ray_main_#t~mem11|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (* (+ honda_main_~z~2.base ray_main_~z~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|) 0)
 (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_main_#t~mem14| |ray_main_#t~mem14|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select #length main_~z~2.base)|
 |ray_(select #length main_~z~2.base)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ honda_main_~z~2.offset ray_main_~z~2.offset) (- 1))
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet5| |ray_main_#t~nondet5|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~mem10| 0) 
 (* |honda_main_#t~mem11| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~mem14| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~nondet7| (* |ray_main_#t~nondet7| lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(select old(#length) main_~z~2.base)|
 (* |ray_(select old(#length) main_~z~2.base)| lambda))
 (= |ray_main_#t~nondet3| (* |ray_main_#t~nondet3| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~z~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~z~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= ray_main_~z~2.base (* ray_main_~z~2.base lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda)) (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select #length main_~z~2.base)|
 (* |ray_(select #length main_~z~2.base)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_main_~z~2.offset (* ray_main_~z~2.offset lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_main_#t~nondet5| (* |ray_main_#t~nondet5| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1)) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 (- 1)) (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 1)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 1)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1)) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1))
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* ray_main_~z~2.offset lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~nondet7| lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_(select old(#length) main_~z~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet3| lambda) 0)
 (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~z~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~z~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem10| lambda) 0) 
 (* (* |ray_main_#t~mem11| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* ray_main_~z~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~z~2.base) main_~z~2.offset)|
 lambda) 0) (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem9| lambda) 0) 
 (* (* |ray_main_#t~mem14| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~z~2.base)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* ray_main_~z~2.offset lambda) (- 1))
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet5| lambda) 0) 
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~z~2.base) main_~z~2.offset)| 0)
 (* |ray_main_#t~mem15| 0) 
 (* |ray_main_#t~mem10| 0) 
 (* |ray_main_#t~mem11| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~mem14| 0)) 0) 
 (= lambda lambda))) (>= lambda 0)))
(check-sat)
(exit)

