(set-logic QF_NIA)
(set-info
  :source |
SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of 
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument [2].

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to the benchmarks from the SV-COMP 2015 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2015-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann:
Geometric Series as Nontermination Arguments for Linear Lasso Programs. 
CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model 
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2015/
[6] Dirk Beyer: Software Verification and Verifiable Witnesses - (Report on 
SV-COMP 2015). TACAS 2015: 401-416
[7] https://svn.sosy-lab.org/software/sv-benchmarks/tags/svcomp15/
|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun |init_main_#t~malloc2.base| () Int)
(declare-fun |honda_main_#t~malloc2.base| () Int)
(declare-fun |ray_main_#t~malloc2.base| () Int)
(declare-fun |init_main_#t~malloc0.base| () Int)
(declare-fun |honda_main_#t~malloc0.base| () Int)
(declare-fun |ray_main_#t~malloc0.base| () Int)
(declare-fun |init_main_#t~mem15| () Int)
(declare-fun |honda_main_#t~mem15| () Int)
(declare-fun |ray_main_#t~mem15| () Int)
(declare-fun |init_main_#t~malloc1.offset| () Int)
(declare-fun |honda_main_#t~malloc1.offset| () Int)
(declare-fun |ray_main_#t~malloc1.offset| () Int)
(declare-fun |init_main_#t~mem6| () Int)
(declare-fun |honda_main_#t~mem6| () Int)
(declare-fun |ray_main_#t~mem6| () Int)
(declare-fun init_main_~d~2.offset () Int)
(declare-fun honda_main_~d~2.offset () Int)
(declare-fun ray_main_~d~2.offset () Int)
(declare-fun |init_main_#t~malloc1.base| () Int)
(declare-fun |honda_main_#t~malloc1.base| () Int)
(declare-fun |ray_main_#t~malloc1.base| () Int)
(declare-fun |init_main_#t~nondet8| () Int)
(declare-fun |honda_main_#t~nondet8| () Int)
(declare-fun |ray_main_#t~nondet8| () Int)
(declare-fun init_main_~y~2.offset () Int)
(declare-fun honda_main_~y~2.offset () Int)
(declare-fun ray_main_~y~2.offset () Int)
(declare-fun |init_main_#t~nondet13| () Int)
(declare-fun |honda_main_#t~nondet13| () Int)
(declare-fun |ray_main_#t~nondet13| () Int)
(declare-fun init_main_~d~2.base () Int)
(declare-fun honda_main_~d~2.base () Int)
(declare-fun ray_main_~d~2.base () Int)
(declare-fun init_main_~x~2.base () Int)
(declare-fun honda_main_~x~2.base () Int)
(declare-fun ray_main_~x~2.base () Int)
(declare-fun |init_main_#t~malloc2.offset| () Int)
(declare-fun |honda_main_#t~malloc2.offset| () Int)
(declare-fun |ray_main_#t~malloc2.offset| () Int)
(declare-fun |init_main_#t~mem17| () Int)
(declare-fun |honda_main_#t~mem17| () Int)
(declare-fun |ray_main_#t~mem17| () Int)
(declare-fun |init_main_#t~mem9| () Int)
(declare-fun |honda_main_#t~mem9| () Int)
(declare-fun |ray_main_#t~mem9| () Int)
(declare-fun |init_#NULL.offset| () Int)
(declare-fun |honda_#NULL.offset| () Int)
(declare-fun |ray_#NULL.offset| () Int)
(declare-fun |init_main_#t~nondet11| () Int)
(declare-fun |honda_main_#t~nondet11| () Int)
(declare-fun |ray_main_#t~nondet11| () Int)
(declare-fun |init_main_#t~malloc0.offset| () Int)
(declare-fun |honda_main_#t~malloc0.offset| () Int)
(declare-fun |ray_main_#t~malloc0.offset| () Int)
(declare-fun init_main_~y~2.base () Int)
(declare-fun honda_main_~y~2.base () Int)
(declare-fun ray_main_~y~2.base () Int)
(declare-fun |init_main_#t~mem4| () Int)
(declare-fun |honda_main_#t~mem4| () Int)
(declare-fun |ray_main_#t~mem4| () Int)
(declare-fun |init_main_#t~mem3| () Int)
(declare-fun |honda_main_#t~mem3| () Int)
(declare-fun |ray_main_#t~mem3| () Int)
(declare-fun init_main_~x~2.offset () Int)
(declare-fun honda_main_~x~2.offset () Int)
(declare-fun ray_main_~x~2.offset () Int)
(declare-fun |init_#NULL.base| () Int)
(declare-fun |honda_#NULL.base| () Int)
(declare-fun |ray_#NULL.base| () Int)
(declare-fun |init_(ite main_#t~short5 1 0)| () Int)
(declare-fun |honda_(ite main_#t~short5 1 0)| () Int)
(declare-fun |ray_(ite main_#t~short5 1 0)| () Int)
(declare-fun |init_(ite main_#t~short7 1 0)| () Int)
(declare-fun |honda_(ite main_#t~short7 1 0)| () Int)
(declare-fun |ray_(ite main_#t~short7 1 0)| () Int)
(declare-fun |init_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |honda_(select old(#length) main_~x~2.base)| () Int)
(declare-fun |ray_(select old(#length) main_~x~2.base)| () Int)
(declare-fun |honda_(select old(#length) main_~y~2.base)| () Int)
(declare-fun |ray_(select old(#length) main_~y~2.base)| () Int)
(declare-fun |honda_(select old(#length) main_~d~2.base)| () Int)
(declare-fun |ray_(select old(#length) main_~d~2.base)| () Int)
(declare-fun |honda_(select #length main_~x~2.base)| () Int)
(declare-fun |ray_(select #length main_~x~2.base)| () Int)
(declare-fun |honda_(select #length main_~y~2.base)| () Int)
(declare-fun |ray_(select #length main_~y~2.base)| () Int)
(declare-fun |honda_(select #length main_~d~2.base)| () Int)
(declare-fun |ray_(select #length main_~d~2.base)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)| ()
  Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)| ()
  Int)
(declare-fun
  |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)| ()
  Int)
(declare-fun
  |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| () Int)
(declare-fun
  |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| () Int)
(declare-fun
  |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| () Int)
(declare-fun |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid main_~x~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~x~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid main_~y~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~y~2.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid main_~d~2.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid main_~d~2.base) 1 0)| () Int)
(declare-fun lambda () Int)
(declare-fun aux_1104 () Int)
(declare-fun aux_1105 () Int)
(declare-fun aux_1108 () Int)
(declare-fun aux_1109 () Int)
(declare-fun aux_1112 () Int)
(declare-fun aux_1113 () Int)
(declare-fun aux_1116 () Int)
(declare-fun aux_1117 () Int)
(declare-fun aux_1120 () Int)
(declare-fun aux_1121 () Int)
(declare-fun aux_1124 () Int)
(declare-fun aux_1125 () Int)
(declare-fun aux_1128 () Int)
(declare-fun aux_1129 () Int)
(declare-fun aux_1132 () Int)
(declare-fun aux_1133 () Int)
(declare-fun aux_1136 () Int)
(declare-fun aux_1137 () Int)
(declare-fun aux_1140 () Int)
(declare-fun aux_1141 () Int)
(declare-fun aux_1144 () Int)
(declare-fun aux_1145 () Int)
(declare-fun aux_1148 () Int)
(declare-fun aux_1149 () Int)
(declare-fun aux_1152 () Int)
(declare-fun aux_1153 () Int)
(declare-fun aux_1156 () Int)
(declare-fun aux_1157 () Int)
(declare-fun aux_1160 () Int)
(declare-fun aux_1161 () Int)
(declare-fun aux_1164 () Int)
(declare-fun aux_1165 () Int)
(declare-fun aux_1168 () Int)
(declare-fun aux_1169 () Int)
(declare-fun aux_1172 () Int)
(declare-fun aux_1173 () Int)
(declare-fun aux_1176 () Int)
(declare-fun aux_1177 () Int)
(declare-fun aux_1180 () Int)
(declare-fun aux_1181 () Int)
(declare-fun aux_1184 () Int)
(declare-fun aux_1185 () Int)
(declare-fun aux_1188 () Int)
(declare-fun aux_1189 () Int)
(declare-fun aux_1192 () Int)
(declare-fun aux_1193 () Int)
(declare-fun aux_1196 () Int)
(declare-fun aux_1197 () Int)
(assert
 (and
 (or
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1104 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1105 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1104 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1105 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1108 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1109 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1108 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1109 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1112 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1113 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1112 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1113 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1116 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1117 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1116 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1117 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1120 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1121 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1120 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1121 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1124 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1125 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1124 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1125 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1128 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1129 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1128 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1129 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1132 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1133 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1132 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1133 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1136 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1137 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1136 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1137 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1140 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1141 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1140 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1141 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1144 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1145 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1144 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1145 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1148 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1149 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1148 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1149 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1152 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1153 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1152 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1153 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1156 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1157 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1156 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1157 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1160 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1161 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1160 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1161 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1164 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1165 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1164 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1165 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1168 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1169 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1168 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1169 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1172 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1173 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1172 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1173 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1176 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1177 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1176 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1177 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1180 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1181 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1180 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1181 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1184 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1185 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1184 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1185 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1188 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1189 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1188 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1189 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1192 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1193 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1192 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 1) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1193 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base (- 1)) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0))
 (and
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 1)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 1)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1196 (- 1)) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1197 1) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 1) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base (- 1)) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| (- 1))
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| (- 1))
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 (- 1)) (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base (- 1)) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset (- 1)) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 1)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 2)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| (- 1))
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 4) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 1) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset (- 1)) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 1)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| (- 1))
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1196 1) (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 1)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 4)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 1)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset (- 1)) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 1) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 1) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 1)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* aux_1197 (- 1)) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 1) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 1) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 0) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 1)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_main_#t~malloc2.base| 0) 
 (* |honda_main_#t~malloc0.base| 0) 
 (* |honda_main_#t~mem15| 0) 
 (* |honda_main_#t~malloc1.offset| 0) 
 (* |honda_main_#t~mem6| 0) 
 (* honda_main_~d~2.offset 0) 
 (* |honda_main_#t~malloc1.base| 0) 
 (* |honda_main_#t~nondet8| 0) 
 (* honda_main_~y~2.offset 0) 
 (* |honda_main_#t~nondet13| 0) 
 (* honda_main_~d~2.base 0) 
 (* honda_main_~x~2.base 0) 
 (* |honda_main_#t~malloc2.offset| 0) 
 (* |honda_main_#t~mem17| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_#NULL.offset| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~malloc0.offset| 0) 
 (* honda_main_~y~2.base 0) 
 (* |honda_main_#t~mem4| 0) 
 (* |honda_main_#t~mem3| 0) 
 (* honda_main_~x~2.offset 0) 
 (* |honda_#NULL.base| 1) 
 (* |honda_(select old(#length) main_~x~2.base)| 0)
 (* |honda_(select old(#length) main_~y~2.base)| 0)
 (* |honda_(select old(#length) main_~d~2.base)| 0)
 (* |honda_(select #length main_~x~2.base)| 0)
 (* |honda_(select #length main_~y~2.base)| 0)
 (* |honda_(select #length main_~d~2.base)| 0)
 (*
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 0)
 (*
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(ite main_#t~short5 1 0)| 0)
 (* |honda_(ite main_#t~short7 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (* |honda_(ite (select old(#valid) main_~d~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~x~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid main_~y~2.base) 1 0)| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (* |honda_(ite (select #valid main_~d~2.base) 1 0)| 0)
 (* |init_main_#t~malloc2.base| 0) 
 (* |init_main_#t~malloc0.base| 0) 
 (* |init_main_#t~mem15| 0) 
 (* |init_main_#t~malloc1.offset| 0) 
 (* |init_main_#t~mem6| 0) 
 (* init_main_~d~2.offset 0) 
 (* |init_main_#t~malloc1.base| 0) 
 (* |init_main_#t~nondet8| 0) 
 (* init_main_~y~2.offset 0) 
 (* |init_main_#t~nondet13| 0) 
 (* init_main_~d~2.base 0) 
 (* init_main_~x~2.base 0) 
 (* |init_main_#t~malloc2.offset| 0) 
 (* |init_main_#t~mem17| 0) 
 (* |init_main_#t~mem9| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_main_#t~nondet11| 0) 
 (* |init_main_#t~malloc0.offset| 0) 
 (* init_main_~y~2.base 0) 
 (* |init_main_#t~mem4| 0) 
 (* |init_main_#t~mem3| 0) 
 (* init_main_~x~2.offset 0) 
 (* |init_#NULL.base| 0) (* |init_(ite main_#t~short5 1 0)| 0)
 (* |init_(ite main_#t~short7 1 0)| 0)
 (* |init_(ite (select #valid 0) 1 0)| 0) 0) 0)))
 (or
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_main_#t~mem15| (+ |honda_main_#t~mem15| |ray_main_#t~mem15|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~d~2.offset (+ honda_main_~d~2.offset ray_main_~d~2.offset))
 (= |honda_(select #length main_~d~2.base)|
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(ite (select #valid main_~d~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_main_#t~nondet13|
 (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|))
 (= honda_main_~d~2.base (+ honda_main_~d~2.base ray_main_~d~2.base))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(select old(#length) main_~d~2.base)|
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|))
 (= |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 1)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| (- 1)) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 1) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 1)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 1) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_main_#t~mem15| (* |ray_main_#t~mem15| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~d~2.offset (* ray_main_~d~2.offset lambda))
 (= |ray_(select #length main_~d~2.base)|
 (* |ray_(select #length main_~d~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(ite (select #valid main_~d~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_main_#t~nondet13| (* |ray_main_#t~nondet13| lambda))
 (= ray_main_~d~2.base (* ray_main_~d~2.base lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(select old(#length) main_~d~2.base)|
 (* |ray_(select old(#length) main_~d~2.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 1)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| (- 1)) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 1) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0)
 (* (* ray_main_~d~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) (- 1))
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 1) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| (- 1)) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 1) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_main_#t~mem15| (+ |honda_main_#t~mem15| |ray_main_#t~mem15|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~d~2.offset (+ honda_main_~d~2.offset ray_main_~d~2.offset))
 (= |honda_(select #length main_~d~2.base)|
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(ite (select #valid main_~d~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_main_#t~nondet13|
 (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|))
 (= honda_main_~d~2.base (+ honda_main_~d~2.base ray_main_~d~2.base))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(select old(#length) main_~d~2.base)|
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|))
 (= |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 1)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| (- 1)) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 1) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 1)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 1) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_main_#t~mem15| (* |ray_main_#t~mem15| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~d~2.offset (* ray_main_~d~2.offset lambda))
 (= |ray_(select #length main_~d~2.base)|
 (* |ray_(select #length main_~d~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(ite (select #valid main_~d~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_main_#t~nondet13| (* |ray_main_#t~nondet13| lambda))
 (= ray_main_~d~2.base (* ray_main_~d~2.base lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(select old(#length) main_~d~2.base)|
 (* |ray_(select old(#length) main_~d~2.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 1)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| (- 1)) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 1) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) (- 1))
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 1) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| (- 1)) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 1) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_main_#t~mem15| (+ |honda_main_#t~mem15| |ray_main_#t~mem15|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~d~2.offset (+ honda_main_~d~2.offset ray_main_~d~2.offset))
 (= |honda_(select #length main_~d~2.base)|
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(ite (select #valid main_~d~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_main_#t~nondet13|
 (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|))
 (= honda_main_~d~2.base (+ honda_main_~d~2.base ray_main_~d~2.base))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(select old(#length) main_~d~2.base)|
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|))
 (= |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 1)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| (- 1)) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 1)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| (- 1)) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 1) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_main_#t~mem15| (* |ray_main_#t~mem15| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~d~2.offset (* ray_main_~d~2.offset lambda))
 (= |ray_(select #length main_~d~2.base)|
 (* |ray_(select #length main_~d~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(ite (select #valid main_~d~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_main_#t~nondet13| (* |ray_main_#t~nondet13| lambda))
 (= ray_main_~d~2.base (* ray_main_~d~2.base lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(select old(#length) main_~d~2.base)|
 (* |ray_(select old(#length) main_~d~2.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 1)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| (- 1)) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0)
 (* (* ray_main_~d~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) (- 1))
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| (- 1)) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 1) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| (- 1)) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 1) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_main_#t~mem15| (+ |honda_main_#t~mem15| |ray_main_#t~mem15|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~d~2.offset (+ honda_main_~d~2.offset ray_main_~d~2.offset))
 (= |honda_(select #length main_~d~2.base)|
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(ite (select #valid main_~d~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_main_#t~nondet13|
 (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|))
 (= honda_main_~d~2.base (+ honda_main_~d~2.base ray_main_~d~2.base))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(select old(#length) main_~d~2.base)|
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|))
 (= |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 1)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| (- 1)) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 1) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 1)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 1) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_main_#t~mem15| (* |ray_main_#t~mem15| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~d~2.offset (* ray_main_~d~2.offset lambda))
 (= |ray_(select #length main_~d~2.base)|
 (* |ray_(select #length main_~d~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(ite (select #valid main_~d~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_main_#t~nondet13| (* |ray_main_#t~nondet13| lambda))
 (= ray_main_~d~2.base (* ray_main_~d~2.base lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(select old(#length) main_~d~2.base)|
 (* |ray_(select old(#length) main_~d~2.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 1)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| (- 1)) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 1) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) (- 1))
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 1) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| (- 1)) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 1) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_main_#t~mem15| (+ |honda_main_#t~mem15| |ray_main_#t~mem15|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~d~2.offset (+ honda_main_~d~2.offset ray_main_~d~2.offset))
 (= |honda_(select #length main_~d~2.base)|
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(ite (select #valid main_~d~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_main_#t~nondet13|
 (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|))
 (= honda_main_~d~2.base (+ honda_main_~d~2.base ray_main_~d~2.base))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(select old(#length) main_~d~2.base)|
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|))
 (= |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 1)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| (- 1)) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 1) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 1)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 1) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_main_#t~mem15| (* |ray_main_#t~mem15| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~d~2.offset (* ray_main_~d~2.offset lambda))
 (= |ray_(select #length main_~d~2.base)|
 (* |ray_(select #length main_~d~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(ite (select #valid main_~d~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_main_#t~nondet13| (* |ray_main_#t~nondet13| lambda))
 (= ray_main_~d~2.base (* ray_main_~d~2.base lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(select old(#length) main_~d~2.base)|
 (* |ray_(select old(#length) main_~d~2.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 1)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| (- 1)) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 1) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) (- 1))
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 1) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0)
 (* (* ray_main_~d~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| (- 1)) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 1) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_main_#t~mem15| (+ |honda_main_#t~mem15| |ray_main_#t~mem15|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~d~2.offset (+ honda_main_~d~2.offset ray_main_~d~2.offset))
 (= |honda_(select #length main_~d~2.base)|
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(ite (select #valid main_~d~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_main_#t~nondet13|
 (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|))
 (= honda_main_~d~2.base (+ honda_main_~d~2.base ray_main_~d~2.base))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(select old(#length) main_~d~2.base)|
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|))
 (= |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 1)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| (- 1)) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 1) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 1)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 1) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_main_#t~mem15| (* |ray_main_#t~mem15| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~d~2.offset (* ray_main_~d~2.offset lambda))
 (= |ray_(select #length main_~d~2.base)|
 (* |ray_(select #length main_~d~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(ite (select #valid main_~d~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_main_#t~nondet13| (* |ray_main_#t~nondet13| lambda))
 (= ray_main_~d~2.base (* ray_main_~d~2.base lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(select old(#length) main_~d~2.base)|
 (* |ray_(select old(#length) main_~d~2.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 1)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| (- 1)) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 1) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0)
 (* (* ray_main_~d~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) (- 1))
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 1) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| (- 1)) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 1) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_main_#t~mem15| (+ |honda_main_#t~mem15| |ray_main_#t~mem15|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~d~2.offset (+ honda_main_~d~2.offset ray_main_~d~2.offset))
 (= |honda_(select #length main_~d~2.base)|
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(ite (select #valid main_~d~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_main_#t~nondet13|
 (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|))
 (= honda_main_~d~2.base (+ honda_main_~d~2.base ray_main_~d~2.base))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(select old(#length) main_~d~2.base)|
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|))
 (= |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 1)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| (- 1)) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 1)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| (- 1)) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 1) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_main_#t~mem15| (* |ray_main_#t~mem15| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~d~2.offset (* ray_main_~d~2.offset lambda))
 (= |ray_(select #length main_~d~2.base)|
 (* |ray_(select #length main_~d~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(ite (select #valid main_~d~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_main_#t~nondet13| (* |ray_main_#t~nondet13| lambda))
 (= ray_main_~d~2.base (* ray_main_~d~2.base lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(select old(#length) main_~d~2.base)|
 (* |ray_(select old(#length) main_~d~2.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 1)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| (- 1)) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0)
 (* (* ray_main_~d~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) (- 1))
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| (- 1)) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 1) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| (- 1)) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 1) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_main_#t~mem15| (+ |honda_main_#t~mem15| |ray_main_#t~mem15|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~d~2.offset (+ honda_main_~d~2.offset ray_main_~d~2.offset))
 (= |honda_(select #length main_~d~2.base)|
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(ite (select #valid main_~d~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_main_#t~nondet13|
 (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|))
 (= honda_main_~d~2.base (+ honda_main_~d~2.base ray_main_~d~2.base))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(select old(#length) main_~d~2.base)|
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|))
 (= |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 1)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| (- 1)) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 1)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| (- 1)) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 1) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_main_#t~mem15| (* |ray_main_#t~mem15| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~d~2.offset (* ray_main_~d~2.offset lambda))
 (= |ray_(select #length main_~d~2.base)|
 (* |ray_(select #length main_~d~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(ite (select #valid main_~d~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_main_#t~nondet13| (* |ray_main_#t~nondet13| lambda))
 (= ray_main_~d~2.base (* ray_main_~d~2.base lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(select old(#length) main_~d~2.base)|
 (* |ray_(select old(#length) main_~d~2.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 1)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| (- 1)) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) (- 1))
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| (- 1)) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 1) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0)
 (* (* ray_main_~d~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| (- 1)) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 1) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_main_#t~mem15| (+ |honda_main_#t~mem15| |ray_main_#t~mem15|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~d~2.offset (+ honda_main_~d~2.offset ray_main_~d~2.offset))
 (= |honda_(select #length main_~d~2.base)|
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(ite (select #valid main_~d~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_main_#t~nondet13|
 (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|))
 (= honda_main_~d~2.base (+ honda_main_~d~2.base ray_main_~d~2.base))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(select old(#length) main_~d~2.base)|
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|))
 (= |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 1)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| (- 1)) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 1) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 1)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 1) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_main_#t~mem15| (* |ray_main_#t~mem15| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~d~2.offset (* ray_main_~d~2.offset lambda))
 (= |ray_(select #length main_~d~2.base)|
 (* |ray_(select #length main_~d~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(ite (select #valid main_~d~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_main_#t~nondet13| (* |ray_main_#t~nondet13| lambda))
 (= ray_main_~d~2.base (* ray_main_~d~2.base lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(select old(#length) main_~d~2.base)|
 (* |ray_(select old(#length) main_~d~2.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 1)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| (- 1)) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 1) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) (- 1))
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 1) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0)
 (* (* ray_main_~d~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| (- 1)) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 1) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_main_#t~mem15| (+ |honda_main_#t~mem15| |ray_main_#t~mem15|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~d~2.offset (+ honda_main_~d~2.offset ray_main_~d~2.offset))
 (= |honda_(select #length main_~d~2.base)|
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(ite (select #valid main_~d~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_main_#t~nondet13|
 (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|))
 (= honda_main_~d~2.base (+ honda_main_~d~2.base ray_main_~d~2.base))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(select old(#length) main_~d~2.base)|
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|))
 (= |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 1)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| (- 1)) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 1)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| (- 1)) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 1) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) (- 1))
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_main_#t~mem15| (* |ray_main_#t~mem15| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~d~2.offset (* ray_main_~d~2.offset lambda))
 (= |ray_(select #length main_~d~2.base)|
 (* |ray_(select #length main_~d~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(ite (select #valid main_~d~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_main_#t~nondet13| (* |ray_main_#t~nondet13| lambda))
 (= ray_main_~d~2.base (* ray_main_~d~2.base lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(select old(#length) main_~d~2.base)|
 (* |ray_(select old(#length) main_~d~2.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 1)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| (- 1)) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) (- 1))
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| (- 1)) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 1) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0)
 (* (* ray_main_~d~2.base lambda) (- 1))
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| (- 1)) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 1) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_main_#t~mem15| (+ |honda_main_#t~mem15| |ray_main_#t~mem15|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~d~2.offset (+ honda_main_~d~2.offset ray_main_~d~2.offset))
 (= |honda_(select #length main_~d~2.base)|
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(ite (select #valid main_~d~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_main_#t~nondet13|
 (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|))
 (= honda_main_~d~2.base (+ honda_main_~d~2.base ray_main_~d~2.base))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(select old(#length) main_~d~2.base)|
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|))
 (= |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 1)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| (- 1)) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 1)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 1)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| (- 1)) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 1) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_main_#t~mem15| (* |ray_main_#t~mem15| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~d~2.offset (* ray_main_~d~2.offset lambda))
 (= |ray_(select #length main_~d~2.base)|
 (* |ray_(select #length main_~d~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(ite (select #valid main_~d~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_main_#t~nondet13| (* |ray_main_#t~nondet13| lambda))
 (= ray_main_~d~2.base (* ray_main_~d~2.base lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(select old(#length) main_~d~2.base)|
 (* |ray_(select old(#length) main_~d~2.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 1)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| (- 1)) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 1)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) (- 1))
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| (- 1)) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 1) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| (- 1)) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 1) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0) 
 (= lambda lambda))
 (and
 (= |honda_main_#t~malloc2.base|
 (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|))
 (= |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|))
 (= |honda_main_#t~malloc0.base|
 (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|))
 (= |honda_main_#t~mem15| (+ |honda_main_#t~mem15| |ray_main_#t~mem15|))
 (=
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|))
 (= |honda_main_#t~malloc1.offset|
 (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|))
 (= |honda_main_#t~malloc1.base|
 (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|))
 (= honda_main_~d~2.offset (+ honda_main_~d~2.offset ray_main_~d~2.offset))
 (= |honda_(select #length main_~d~2.base)|
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|))
 (= honda_main_~y~2.offset (+ honda_main_~y~2.offset ray_main_~y~2.offset))
 (= |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|))
 (= |honda_(ite (select #valid main_~x~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|))
 (= |honda_(select #length main_~y~2.base)|
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|))
 (= |honda_(ite (select #valid main_~d~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|))
 (= |honda_(select old(#length) main_~x~2.base)|
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (= |honda_main_#t~nondet13|
 (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|))
 (= honda_main_~d~2.base (+ honda_main_~d~2.base ray_main_~d~2.base))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= honda_main_~x~2.base (+ honda_main_~x~2.base ray_main_~x~2.base))
 (= |honda_main_#t~malloc2.offset|
 (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|))
 (= |honda_main_#t~mem17| (+ |honda_main_#t~mem17| |ray_main_#t~mem17|))
 (= |honda_(select old(#length) main_~d~2.base)|
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|))
 (= |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|))
 (=
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_main_#t~malloc0.offset|
 (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|))
 (= honda_main_~y~2.base (+ honda_main_~y~2.base ray_main_~y~2.base))
 (= |honda_(select #length main_~x~2.base)|
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|))
 (= |honda_(ite (select #valid main_~y~2.base) 1 0)|
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|))
 (= honda_main_~x~2.offset (+ honda_main_~x~2.offset ray_main_~x~2.offset))
 (= |honda_(select old(#length) main_~y~2.base)|
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 1)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 1)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| (- 1)) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 1)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 1)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) (- 1))
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| (- 1)) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 1)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 4)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 1)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 1)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 1)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) (- 1))
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 
 (- 1)) (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 1) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) (- 1))
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 1)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| (- 1)) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 1) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) (- 1))
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 
 (- 1))
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 1) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 1)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 1)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) (- 1))
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 1)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 0)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 
 (- 1)) 0)
 (>=
 (+ (* (+ |honda_main_#t~malloc2.base| |ray_main_#t~malloc2.base|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~y~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|) 0)
 (* (+ |honda_main_#t~malloc0.base| |ray_main_#t~malloc0.base|) 0)
 (* (+ |honda_(ite main_#t~short5 1 0)| |ray_(ite main_#t~short5 1 0)|) 0)
 (* (+ |honda_main_#t~mem15| |ray_main_#t~mem15|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.offset| |ray_main_#t~malloc1.offset|) 0)
 (* (+ |honda_main_#t~mem6| |ray_main_#t~mem6|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|) 0)
 (* (+ |honda_main_#t~malloc1.base| |ray_main_#t~malloc1.base|) 0)
 (* (+ honda_main_~d~2.offset ray_main_~d~2.offset) 0)
 (*
 (+ |honda_(select #length main_~d~2.base)|
 |ray_(select #length main_~d~2.base)|) 0)
 (* (+ |honda_main_#t~nondet8| |ray_main_#t~nondet8|) 0)
 (* (+ honda_main_~y~2.offset ray_main_~y~2.offset) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) main_~x~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~x~2.base) 1 0)|
 |ray_(ite (select #valid main_~x~2.base) 1 0)|) 0)
 (*
 (+ |honda_(select #length main_~y~2.base)|
 |ray_(select #length main_~y~2.base)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~d~2.base) 1 0)|
 |ray_(ite (select #valid main_~d~2.base) 1 0)|) 0)
 (* (+ |honda_(ite main_#t~short7 1 0)| |ray_(ite main_#t~short7 1 0)|) 0)
 (*
 (+ |honda_(select old(#length) main_~x~2.base)|
 |ray_(select old(#length) main_~x~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (* (+ |honda_main_#t~nondet13| |ray_main_#t~nondet13|) 0)
 (* (+ honda_main_~d~2.base ray_main_~d~2.base) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0) (* (+ honda_main_~x~2.base ray_main_~x~2.base) 0)
 (* (+ |honda_main_#t~malloc2.offset| |ray_main_#t~malloc2.offset|) 0)
 (* (+ |honda_main_#t~mem17| |ray_main_#t~mem17|) 0)
 (*
 (+ |honda_(select old(#length) main_~d~2.base)|
 |ray_(select old(#length) main_~d~2.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) main_~d~2.base) 1 0)|
 |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|) 0)
 (* (+ |honda_main_#t~mem9| |ray_main_#t~mem9|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (* (+ |honda_main_#t~nondet11| |ray_main_#t~nondet11|) 0)
 (* (+ |honda_main_#t~malloc0.offset| |ray_main_#t~malloc0.offset|) 0)
 (* (+ honda_main_~y~2.base ray_main_~y~2.base) 0)
 (*
 (+ |honda_(select #length main_~x~2.base)|
 |ray_(select #length main_~x~2.base)|) 0)
 (* (+ |honda_main_#t~mem4| |ray_main_#t~mem4|) 0)
 (*
 (+ |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|) 0)
 (*
 (+ |honda_(ite (select #valid main_~y~2.base) 1 0)|
 |ray_(ite (select #valid main_~y~2.base) 1 0)|) 0)
 (* (+ honda_main_~x~2.offset ray_main_~x~2.offset) 1)
 (* (+ |honda_main_#t~mem3| |ray_main_#t~mem3|) 0)
 (*
 (+ |honda_(select old(#length) main_~y~2.base)|
 |ray_(select old(#length) main_~y~2.base)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_(ite main_#t~short5 1 0)| 0) 
 (* |honda_main_#t~mem6| 0)
 (* |honda_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |honda_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |honda_main_#t~nondet8| 0) 
 (* |honda_(ite main_#t~short7 1 0)| 0) 
 (* |honda_main_#t~mem9| 0) 
 (* |honda_main_#t~nondet11| 0) 
 (* |honda_main_#t~mem4| 0)
 (* |honda_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |honda_main_#t~mem3| 0) 0) 0)
 (= |ray_main_#t~malloc2.base| (* |ray_main_#t~malloc2.base| lambda))
 (= |ray_(ite (select old(#valid) main_~y~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda))
 (= |ray_main_#t~malloc0.base| (* |ray_main_#t~malloc0.base| lambda))
 (= |ray_main_#t~mem15| (* |ray_main_#t~mem15| lambda))
 (= |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda))
 (= |ray_main_#t~malloc1.offset| (* |ray_main_#t~malloc1.offset| lambda))
 (= |ray_main_#t~malloc1.base| (* |ray_main_#t~malloc1.base| lambda))
 (= ray_main_~d~2.offset (* ray_main_~d~2.offset lambda))
 (= |ray_(select #length main_~d~2.base)|
 (* |ray_(select #length main_~d~2.base)| lambda))
 (= ray_main_~y~2.offset (* ray_main_~y~2.offset lambda))
 (= |ray_(ite (select old(#valid) main_~x~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda))
 (= |ray_(ite (select #valid main_~x~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda))
 (= |ray_(select #length main_~y~2.base)|
 (* |ray_(select #length main_~y~2.base)| lambda))
 (= |ray_(ite (select #valid main_~d~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda))
 (= |ray_(select old(#length) main_~x~2.base)|
 (* |ray_(select old(#length) main_~x~2.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (= |ray_main_#t~nondet13| (* |ray_main_#t~nondet13| lambda))
 (= ray_main_~d~2.base (* ray_main_~d~2.base lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= ray_main_~x~2.base (* ray_main_~x~2.base lambda))
 (= |ray_main_#t~malloc2.offset| (* |ray_main_#t~malloc2.offset| lambda))
 (= |ray_main_#t~mem17| (* |ray_main_#t~mem17| lambda))
 (= |ray_(select old(#length) main_~d~2.base)|
 (* |ray_(select old(#length) main_~d~2.base)| lambda))
 (= |ray_(ite (select old(#valid) main_~d~2.base) 1 0)|
 (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda))
 (= |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda))
 (= |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda)) (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_main_#t~malloc0.offset| (* |ray_main_#t~malloc0.offset| lambda))
 (= ray_main_~y~2.base (* ray_main_~y~2.base lambda))
 (= |ray_(select #length main_~x~2.base)|
 (* |ray_(select #length main_~x~2.base)| lambda))
 (= |ray_(ite (select #valid main_~y~2.base) 1 0)|
 (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda))
 (= ray_main_~x~2.offset (* ray_main_~x~2.offset lambda))
 (= |ray_(select old(#length) main_~y~2.base)|
 (* |ray_(select old(#length) main_~y~2.base)| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 1)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 1)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 1)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| (- 1)) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 1)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 1)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) (- 1))
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| (- 1)) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 1)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 1) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 (- 1)) (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 1) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 1)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) (- 1))
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) (- 1)) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 1) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) (- 1))
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 1)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 1)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| (- 1)) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) (- 1))
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) (- 1))
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 1) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 1)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 1)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) (- 1))
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0) 
 (* (* ray_main_~y~2.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 1)
 (* (* ray_main_~x~2.offset lambda) 0) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0)
 (>=
 (+ (* (* |ray_main_#t~malloc2.base| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~y~2.base) 1 0)| lambda) 0)
 (* (* |ray_main_#t~malloc0.base| lambda) 0)
 (* (* |ray_(ite main_#t~short5 1 0)| lambda) 0)
 (* (* |ray_main_#t~mem15| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~x~2.base) main_~x~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.offset| lambda) 0)
 (* (* |ray_main_#t~mem6| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)|
 lambda) 0) (* (* |ray_main_#t~malloc1.base| lambda) 0)
 (* (* ray_main_~d~2.offset lambda) 0)
 (* (* |ray_(select #length main_~d~2.base)| lambda) 0)
 (* (* |ray_main_#t~nondet8| lambda) 0)
 (* (* ray_main_~y~2.offset lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~x~2.base) 1 0)| lambda) 0)
 (* (* |ray_(select #length main_~y~2.base)| lambda) 0)
 (* (* |ray_(ite (select #valid main_~d~2.base) 1 0)| lambda) 0)
 (* (* |ray_(ite main_#t~short7 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) main_~x~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (* (* |ray_main_#t~nondet13| lambda) 0) 
 (* (* ray_main_~d~2.base lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.base lambda) 0)
 (* (* |ray_main_#t~malloc2.offset| lambda) 0)
 (* (* |ray_main_#t~mem17| lambda) 0)
 (* (* |ray_(select old(#length) main_~d~2.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) main_~d~2.base) 1 0)| lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~d~2.base) main_~d~2.offset)|
 lambda) 0)
 (*
 (* |ray_(select (select old(#memory_int) main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_main_#t~mem9| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0) 
 (* (* |ray_main_#t~nondet11| lambda) 0)
 (* (* |ray_main_#t~malloc0.offset| lambda) 0)
 (* (* ray_main_~y~2.base lambda) 0)
 (* (* |ray_(select #length main_~x~2.base)| lambda) 0)
 (* (* |ray_main_#t~mem4| lambda) 0)
 (*
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)|
 lambda) 0) (* (* |ray_(ite (select #valid main_~y~2.base) 1 0)| lambda) 0)
 (* (* ray_main_~x~2.offset lambda) 1) 
 (* (* |ray_main_#t~mem3| lambda) 0)
 (* (* |ray_(select old(#length) main_~y~2.base)| lambda) 0)
 (* (* |ray_#NULL.base| lambda) 0) 
 (* |ray_(ite main_#t~short5 1 0)| 0) 
 (* |ray_main_#t~mem6| 0)
 (* |ray_(select (select #memory_int main_~x~2.base) main_~x~2.offset)| 0)
 (* |ray_(select (select #memory_int main_~d~2.base) main_~d~2.offset)| 0)
 (* |ray_main_#t~nondet8| 0) 
 (* |ray_(ite main_#t~short7 1 0)| 0) 
 (* |ray_main_#t~mem9| 0) 
 (* |ray_main_#t~nondet11| 0) 
 (* |ray_main_#t~mem4| 0)
 (* |ray_(select (select #memory_int main_~y~2.base) main_~y~2.offset)| 0)
 (* |ray_main_#t~mem3| 0)) 0) 
 (= lambda lambda))) (>= lambda 0)))
(check-sat)
(exit)

